Package io.vertx.reactivex.ext.web.sstore.cookie

## Class CookieSessionStore

- java.lang.Object
- - io.vertx.reactivex.ext.web.sstore.SessionStore
  - - io.vertx.reactivex.ext.web.sstore.cookie.CookieSessionStore

-     public class CookieSessionStore
      extends SessionStore

  A SessionStore that uses a Cookie to store the session data. All data is stored in encrypted form using `AES-256 with AES/CBC/PKCS5Padding`.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<CookieSessionStore>` | `__TYPE_ARG` |
    `static int` | `DEFAULT_SESSIONID_LENGTH` | Default length for a session id.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CookieSessionStore​(CookieSessionStore delegate)` |
    `CookieSessionStore​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static CookieSessionStore` | `create​(Vertx vertx, String secret, Buffer salt)` | Creates a CookieSessionStore.
    `boolean` | `equals​(Object o)` |
    `CookieSessionStore` | `getDelegate()` |
    `int` | `hashCode()` |
    `static CookieSessionStore` | `newInstance​(CookieSessionStore arg)` |
    `String` | `toString()` |

    - ### Methods inherited from class io.vertx.reactivex.ext.web.sstore.SessionStore

      `clear, close, create, create, createSession, createSession, delete, get, init, newInstance, put, retryTimeout, rxClear, rxDelete, rxGet, rxPut, rxSize, size`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<CookieSessionStore> __TYPE_ARG

    - #### DEFAULT_SESSIONID_LENGTH

          public static final int DEFAULT_SESSIONID_LENGTH

      Default length for a session id. More info: https://www.owasp.org/index.php/Session_Management_Cheat_Sheet
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CookieSessionStore

          public CookieSessionStore​(CookieSessionStore delegate)

    - #### CookieSessionStore

          public CookieSessionStore​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `SessionStore`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `SessionStore`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `SessionStore`

    - #### getDelegate

          public CookieSessionStore getDelegate()

      Overrides:
        `getDelegate` in class `SessionStore`

    - #### create

          public static CookieSessionStore create​(Vertx vertx,
                                                  String secret,
                                                  Buffer salt)

      Creates a CookieSessionStore. Cookie data will be encrypted using the given secret and salt. The secret as the name reflects, should never leave the server, otherwise user agents could tamper with the payload. The salt adds an extra later of security and should be a random.
      Parameters:
        `vertx` - a vert.x instance
        `secret` - a secret to derive a secure private key
        `salt` - a binary salt used in the key derivation
      Returns:
        the store

    - #### newInstance

          public static CookieSessionStore newInstance​(CookieSessionStore arg)